<?php

/* utf8-marker = äöü
==========================================
CMSimple Plugin LoginLocker
Version loginlocker 2.8
Release: 2023-01-14
Idea: Gert Ebersbach http://www.ge-webdesign.de
Programming: Martin Damken http://www.zeichenkombinat.de
==========================================
License: GPL3 - no warranties
==========================================
*/

if(!defined('CMSIMPLE_VERSION'))
{
	return;
}

$loginlocker_version = '2.8';

if (isset($_POST['loginlocker']) && $_POST['loginlocker'] === 'touch')
{
    include dirname(__FILE__) . DIRECTORY_SEPARATOR . 'LoginLocker.php';
    $locker = new CMSimpleLoginLock(urldecode($_POST['currentDir']), $_POST['token']);
    $locker->lock();
    return;
}

if (!defined('PLUGINLOADER'))
{
    die('Plugin ' . basename(dirname(__FILE__)) . ' requires a newer version of the Pluginloader. No direct access.');
}

if (!($adm || isset($_GET['logged-out']) || $f === 'login' || $logout === 'true'))
{
    return true;
}

if ((!defined('CMSIMPLE_RELEASE') || CMSIMPLE_RELEASE < 2013040201) && $plugin_cf['loginlocker']['version_check'] == 'true')
{
    $o .= '<p class="cmsimplecore_warning" style="text-align: center;">' . $plugin_tx['loginlocker']['requirements'] . '</p>';
    return true;
} else
{
    if ($adm && $plugin_cf['loginlocker']['message_loginlocker_active'] == 'true')
    {
        $o .= '<p class="cmsimplecore_warning" style="padding: 10px 20px; text-align: center;">' . $plugin_tx['loginlocker']['message_ll_active'] . '</p>';
    }
}

if (!session_id())
{
    session_start();
}

require_once $pth['folder']['plugins'] . 'loginlocker/LoginLocker.php';
$loginLocker = new CMSimpleLoginLock();

if ($logout === 'true')
{
    $loginLocker->unlock();
    return true;
}

if ($loginLocker->isLocked())
{
    $loginLocker->error('locked');

    setcookie('status' . str_replace('.','xc6oMd3Rs689',str_replace('index.php','',$sn)), 'adm', time() - 3600);
    setcookie('status', 'adm', time() - 3600, CMSIMPLE_ROOT);
    setcookie('passwd', '', time() - 3600);
    setcookie('mode', 'edit', time() - 3600);
    $adm   = false;
    $f     = '';
    $login = false;
    return true;
}

if (!$login && $loginLocker->hasExpired($adm))
{
    $loginLocker->logOut();
}

if (isset($_GET['logged-out']))
{
    $loginLocker->error('expired', date('i:s', $loginLocker->max_inactivity));
    return true;
}

if (!$adm)
{
    return true;
}

$loginLocker->lock();

include_once($pth['folder']['plugins'] . 'jquery/jquery.inc.php');
include_jQuery();
include_jQueryUI();

$timer   = ($loginLocker->max_inactivity ) * 1000;
$time    = (int) $loginLocker->max_inactivity;
$seconds = $time % 60;
$minutes = (($time - $seconds) / 60);
$seconds = $seconds >= 10 ? (string) $seconds : '0' . (string) $seconds;
$warn    = $loginLocker->translate('warn2', array(date('i:s', $loginLocker->warn_before), $minutes, $seconds));

$o .= '<div id="message" class="cmsimplecore_warning">
<p>' . $plugin_tx['loginlocker']['warn1'] . '</p>
<p><b><span id="logout-in">' . $warn . '</span></b> ' . $plugin_tx['loginlocker']['warn3'] . '</p>
<p>' . $plugin_tx['loginlocker']['warn4'] . '</p>
</div>
<script>
// jQuery.noConflict();
    var lltimer = ' . $timer . ';

    jQuery("#message").dialog({
        autoOpen: false,
        buttons:  [
            { text: "' . $loginLocker->translate('stay_logged_in') . '",
            click: function() {
                stayLoggedIn();
                }
            }
            ]
    }).parent().css("position", "fixed");

    function stayLoggedIn(){
        jQuery.ajax({
            type : "POST",
            url : "' . $pth['folder']['plugins'] . 'loginlocker/index.php",
            data : {
                "loginlocker" : "touch",
                "currentDir"  : "' . urlencode(realpath(getcwd())) . '",
                "token" : "' . session_id() . '"
                },
            success : function(data){
//				jQuery("#message").dialog("close");
                lltimer = 0;
            }
        });
    };

    function login_timeout(){
        if (lltimer <= ' . ($loginLocker->warn_before * 1000) . ')
        {
            jQuery("#message").dialog("open");
        }
        seconds = lltimer/1000;
        strLeft = Math.floor(seconds/60) + ":";
        strLeft += seconds%60 < 10 ? "0" + seconds%60 : seconds%60;

        jQuery("#logout-in").text(strLeft);

        window.setTimeout(\'login_timeout()\', 1000);
        if(lltimer == 0)
        {
            window.onbeforeunload = null;
            window.location.href = window.location;
        }
        lltimer = lltimer-1000;
    }

    window.setTimeout(\'login_timeout()\', 1000);
</script>';
?>